#pragma once

#include "CoreMinimal.h"
#include "GameObjective_ActivatedGenerators.h"
#include "GameObjective_ActivatedGenerators_FuelGenerators.generated.h"

UCLASS(Blueprintable)
class SPRING2025_API AGameObjective_ActivatedGenerators_FuelGenerators : public AGameObjective_ActivatedGenerators
{
	GENERATED_BODY()

private:
	UPROPERTY(EditAnywhere, BlueprintReadWrite, ReplicatedUsing=OnRep_StandardGeneratorCount, meta=(AllowPrivateAccess=true))
	int32 _standardGeneratorCount;

	UPROPERTY(EditAnywhere, BlueprintReadWrite, ReplicatedUsing=OnRep_FuelGeneratorCount, meta=(AllowPrivateAccess=true))
	int32 _fuelGeneratorCount;

private:
	UFUNCTION(BlueprintCallable)
	void OnRep_StandardGeneratorCount(int32 previousCount);

	UFUNCTION(BlueprintCallable)
	void OnRep_FuelGeneratorCount(int32 previousCount);

public:
	UFUNCTION(BlueprintPure)
	int32 GetStandardGeneratorCount() const;

	UFUNCTION(BlueprintPure)
	int32 GetFuelGeneratorCount() const;

public:
	virtual void GetLifetimeReplicatedProps(TArray<FLifetimeProperty>& OutLifetimeProps) const override;

public:
	AGameObjective_ActivatedGenerators_FuelGenerators();
};

FORCEINLINE uint32 GetTypeHash(const AGameObjective_ActivatedGenerators_FuelGenerators) { return 0; }
